;
;	>> Grey 39 Birthday Intro <<
;
;	A little birthday suprise for the greytest
;	party organizer in our little Atari world!
;	(c) JAC! on 2017-12-21
;
;	Remix if the ABBUC Magazin 69 Intro
;	(c) JAC! on 2002-06-02
;
;
;	START - will leave by reset
;	SELECT - will restart the demo
;
;	I hope I'll see you all at SillyVenture 2k18!



gsm		= $2000	;$400 bytes
gchr		= $2400	;$400 bytes
glines		= 64
ganim		= $2800	;$800 bytes

abbuc_pic	= $3000	;$960 bytes
abbuc_width	= 40
abbuc_height	= 60
sinus		= $3a00	;$100 bytes
bounce_sin	= $3c00	;$400 bytes

; Sound routines and data.
sound		= $4000	;$4000-$567c
sound_init	= $4007
sound_replay	= $5252

chr		= $5800	;$1670
chr_width	= 3
chr_height	= 41
chr_bpl		= 40
chr_block	= [chr_height*chr_bpl]

;Player-missle graphics, display list and screen memories.
pm		= $d800
pm_xstart	= $88
pm_xoffset	= $1d
pm_yoffset1	= $20
pm_yoffset2	= $20+60+9*8
pm_yoffset3	= $20+60+4

dl		= $6c00	;

ssm		= $8800	;$1480
ssm_width	= 128

sm		= $a000	;$1e00 bytes
sm_left		= 4+40
sm_right	= 4+40
sm_width	= abbuc_width+sm_left+sm_right

;Various spaces.
*		= $c000
ctaba		.ds $80
ctabb		.ds $80

ctab01		.ds $80
ctab02		.ds $80
ctab03		.ds $80
ctab04		.ds $80
ctab05		.ds $80

ctab11		.ds $80
ctab12		.ds $80
ctab13		.ds $80
ctab14		.ds $80
ctab15		.ds $80

gtab1		.ds $80
gtab2		.ds $80

bsinus		.ds $100
csinus		.ds $100

allcols		.ds $100

xscroll0	.ds 1
offset0		.ds 1

xscroll1	.ds 1
offset1		.ds 1

bounce_flag	.ds 1
bounce_dir	.ds 1
bounce_cnt	.ds 2	;Word
frame_color	.ds 1
scroll_flag	.ds 1
gchr_flag	.ds 1
pm69_flag	.ds 1
anim_flag	.ds 1
digit		.ds 7
buffer1		.ds 8	;gchr buffer
buffer2		.ds 8
brkflag		.ds 1

;================================================================
*	= $e0
p1	.ds 2		;General_pointers
p2	.ds 2
p3	.ds 2
pp	.ds 2		;Print pointer
tp	.ds 2		;Text pointer

*	= $f0
x1	.ds 1		;Temporaries
x2	.ds 1
x3	.ds 1


cnt	= $ff		;Frame_counter

;================================================================
; Shadow registers.

dmacon	= $22f	;Antic_DMA_Control
color0	= $2c8	;Playfield_color_0
color1	= $2c4	;Playfield_color_1
color2	= $2c5	;Playfield_color_2
color3	= $2c6	;Playfield_color_3

;================================================================

	.include "Macros.inc"

;================================================================
*	= $7000

start
	jsr init_screen
	jsr init_pm
	jsr init_gchr
	jsr init_ctab
	jsr init_gtab
	jsr init_allcols
	jsr fill_sm
	jsr clear_ssm
	jsr sound_init

	lda #$00
	sta color0
	lda #$06
	sta color1
	lda #$0a
	sta color2
	lda #$00
	sta color3

	lda #0
	sta bounce_dir
	sta bounce_cnt
	sta bounce_cnt+1
	sta bounce_flag
	sta frame_color
	sta scroll_flag
	sta gchr_flag
	sta pm69_flag
	sta anim_flag
	
	lda #$00
	jsr set_number

	ldx #0
	ldy #0
init_sinus
	lda sinus,x
	lsr
	lsr
	lsr
	sta bsinus,y
	lda sinus,y
	lsr
	lsr
	sta csinus,y
	inx
	inx
	inx
	iny
	bne init_sinus

	jsr set_lms
	jsr screen_on

main
	lda #50
	jsr wait


	lda #1
	sta bounce_flag

	lda #100
	jsr wait

	jsr frame_on

	jsr gchr_blendin

	lda #$00
	sta x3
eff2	jsr set_number
	lda #7
	jsr wait
	sed
	clc
	lda x3
	adc #1
	sta x3
	cld
	cmp #$40
	bne eff2
	
	lda #50
	jsr wait
	lda #1
	sta anim_flag

	lda #100
	jsr wait
	jsr anim_ctab
	lda #50
	jsr wait
	
eff4	set tp,text1
	jsr eff5
;	set tp,text2
;	jsr eff5
	lda #1
	sta bounce_dir
	sta bounce_flag
eff4a	lda bounce_flag
	bne eff4a
	jsr gchr_blendout
	jsr frame_off
	jmp leave
	
eff5	jsr gchr_blendout
	lda #50
	jsr wait
	jsr scroll_on
	jsr scroll
	jsr frame
	jsr scroll_off
	jsr frame
	jsr gchr_blendin
	lda #50
	jsr wait
	jsr anim_ctab
	rts

;=================================================================
frame_on
	ldx #0
frame_on1
	jsr frame
	stx frame_color
	inx
	cpx #16
	bne frame_on1
	jsr frame

	lda #50
	jsr wait
	rts
	
;=================================================================

frame_off
	ldx #15
frame_off1
	jsr frame
	stx frame_color
	dex
	bpl frame_off1
	jsr frame

	lda #50
	jsr wait
	rts

;=================================================================
gchr_blendin
	ldx #[blend1-blend]-1
gchr_blendin1
	lda blend,x
	sta gchr_flag
	jsr frame
	dex
	bpl gchr_blendin1

	lda #50
	jsr wait

	ldx #[blend1-blend]-1
gchr_blendin2
	lda blend,x
	sta pm69_flag
	jsr frame
	dex
	bpl gchr_blendin2

	lda #25
	jsr wait
	rts

gchr_blendout
	ldx #0
gchr_blendout1
	lda blend,x
	sta gchr_flag
	sta pm69_flag
	jsr frame
	inx
	cpx #[blend1-blend]
	bne gchr_blendout1
	rts

blend	.byte 1,0,1,0,1,0,1,0,1,0,0,1,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0
blend1

;=================================================================
init_screen
	cld			;Clear/Reset_all.
	sei
	lda #0
	sta $d40e
	sta $d20e
	tax
init_screen1
	sta $d400,x
	sta $d000,x
	sta $d200,x
	inx
	bne init_screen1
	sta dmacon		;Black_Screen.
	sta color0
	sta color1
	sta color2
	sta color3

	lda #3			;Init POKEY.
	sta $d20f
	lda #$fe		;Full RAM.
	sta $d301
	set $fffa,nmi		;Init_NMI.

	lda #3			;Init PM graphics.
	sta $d01d
	lda #>pm
	sta $d407
	
	ldy #>[pm+$300]		;Clear PM memory.
	ldx #5
	jsr clear_mem

	lda #>chr
	sta $d409

	set $230,dl		;Vectors.
	set $222,vbi

	lda #0
	sta cnt			;Reset_Counter.
	rts

screen_on
	lda $d40b
	bne *-3
	lda #$40		;Enable_NMI.
	sta $d40e
	jsr frame
	lda #$3f		;Shadow_Regs.
	sta dmacon
	rts

;===============================================================
fill_sm
	ldx #abbuc_height
	set p1,abbuc_pic
	set p2,sm
fill_sm1
	ldy #sm_left-1
	lda #$ff
fill_sm2
	sta (p2),y
	dey
	bpl fill_sm2
	add p2,sm_left
	ldy #abbuc_width-1
fill_sm3
	lda (p1),y
	sta (p2),y
	dey
	bpl fill_sm3
	add p1,abbuc_width
	add p2,abbuc_width
	
	ldy #sm_right-1
	lda #$ff
fill_sm4
	sta (p2),y
	dey
	bpl fill_sm4
	add p2,sm_right

	dex
	bne fill_sm1
	rts

;===============================================================
clear_ssm
	ldx #$15
	ldy #>ssm
	
	jmp clear_mem

;===============================================================
clear_mem
	lda #0
fill_mem
	sty p1+1		;A=pattern,X=number of pages,Y=start page
	ldy #0
	sty p1
fill_mem1
	sta (p1),y
	iny
	bne fill_mem1
	inc p1+1
	dex
	bne fill_mem1
	rts

;===============================================================
framex	.byte 0
frame	stx framex
	lda cnt			;Wait_one_frame.
frame1
;;	ldx $d40b
;;	stx $d01a
	cmp cnt
	beq frame1
	ldx framex
	rts

wait	clc			;Wait_<Ac>_frames.
	adc cnt
wait1	cmp cnt
	bne wait1
	rts

;===============================================================
nmi	pha			;Push registers.
	txa
	pha
	tya
	pha

	bit $d40f
	bpl vbi

	lda #15
	jsr kernel_wait
	jsr kernel_a1
	lda #46
	jsr kernel_wait
	lda scroll_flag
	bne nmi1
	jsr kernel_g1
	jmp nmi2
nmi1	jsr kernel_s1
nmi2	lda #81
	jsr kernel_wait
	jsr kernel_a2
	jsr sound_replay

	lda x1			;Push zeropage.
	pha
	lda x2
	pha
	lda x3
	pha
	lda p1
	pha
	lda p1+1
	pha
	lda p2
	pha
	lda p2+1
	pha

	jsr set_lms
	jsr anim_gchr
	jsr bounce

	pla			;Pop zeropage.
	sta p2+1
	pla
	sta p2
	pla
	sta p1+1
	pla
	sta p1
	pla
	sta x3
	pla
	sta x2
	pla
	sta x1
	
	jmp keys

nmix	pla		;Pop registers
	tay
	pla
	tax
	pla
	rti


;===============================================================
vbi	lda dmacon
	sta $d400
	lda $230
	sta $d402
	lda $231
	sta $d403
	lda #$c0		;Enable_DLI.
	sta $d40e
	inc cnt
	jmp nmix
	

;===============================================================
keys	lda #8
	sta $d01f
	lda $d01f
	lsr
	bcs nostart
leave	sei
	lda #0
	sta $d40e
	lda #$ff
	sta $d301
	jmp $e474
nostart	lsr
	bcs noselect
	pla
	pla
	pla
	pla
	pla
	pla
	pla
	pla
	pla
	pla
	jmp start
noselect
	jmp nmix

;===============================================================

kernel_wait
;;	ldx $d20a
;;	stx $d01a
	cmp $d40b
	bne kernel_wait
	rts
	
;===============================================================
	.rept 10
	.byte 0
	.endr
	
kernel_a1
	sta $d40a
	lda color1
	sta $d016
	lda color2
	sta $d017
	lda color3
	sta $d018
	lda #$14
	sta $d01b

	lda xscroll0
	sta $d404
	lda offset0
	clc
	adc #pm_xstart
	sta $d000
	clc
	adc #pm_xoffset
	sta $d001
	clc
	adc #pm_xoffset
	sta $d002
	clc
	adc #pm_xoffset
	sta $d003

	ldx #abbuc_height-1
kernel_a11
	lda ctab01+1,x
	sta $d40a
	sta $d012
	lda ctab02+1,x
	sta $d013
	lda ctab03+1,x
	sta $d014
	lda ctab04+1,x
	sta $d015
	lda ctab05,x
	sta $d01a
	dex
	bpl kernel_a11
	lda #0
	sta $d01a
	rts

;=============================================================

kernel_a2
	lda dmacon
	sta $d400
	lda color1
	sta $d016
	lda color2
	sta $d017
	lda color3
	sta $d018
	lda #$14
	sta $d01b
	sta $d40a

	lda xscroll1
	sta $d404
	lda offset1
	clc
	adc #pm_xstart
	sta $d000
	clc
	adc #pm_xoffset
	sta $d001
	clc
	adc #pm_xoffset
	sta $d002
	clc
	adc #pm_xoffset
	sta $d003

	ldx #abbuc_height-1
kernel_a21
	lda ctab11+1,x
	sta $d40a
	sta $d012
	lda ctab12+1,x
	sta $d013
	lda ctab13+1,x
	sta $d014
	lda ctab14+1,x
	sta $d015
	lda ctab15,x
	sta $d01a
	dex
	bpl kernel_a21
	
	lda #0
	sta $d01a
	rts


;===============================================================
kernel_g1
	lda #$71
	sta $d01b
	lda #>gchr
	sta $d409
	lda #$3e
	sta $d400
	sta $d40a
	sta $d40a

	lda #0		;Black Border
	sta $d012
	sta $d013
	lda frame_color
	sta $d014
	sta $d015
	lda #$0f
	sta $d000
	lda #$d1
	sta $d001
	lda #$10
	sta $d002
	lda #$d0
	sta $d003
	
	lda pm69_flag
	beq *+4
	lda #$6e
	sta $d007
	clc
	adc #8
	sta $d006
	adc #16-4
	sta $d005
	adc #8
	sta $d004

	lda gchr_flag
	eor #1
	sta $d401

	lda frame_color
	sta $d40a
	sta $d01a
	
kernel_g2
	.rept 64
	lda gtab1+[[*-kernel_g2]/15]
	ldy gtab2+[[*-kernel_g2-3]/15]
	sta $d40a
	sta $d01a
	sty $d019
	.endr
	lda frame_color
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a
	rts

;===============================================================
kernel_s1
	lda #$01
	sta $d01b
	lda #$3e
	sta $d400
	sta $d40a
	sta $d40a

	lda #0		;Black Border
	sta $d012
	sta $d013
	lda frame_color
	sta $d014
	sta $d015
	lda #$0f
	sta $d000
	lda #$d1
	sta $d001
	lda #$10
	sta $d002
	lda #$d0
	sta $d003
	
	lda scrsoft
	clc
	adc #3
	sta $d404

	lda frame_color
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a

	ldy scrcol
	lda allcols,y
	and #$f0
	ora #$00
	sta $d018

	lda #53
	jsr kernel_wait

	ldx #0
kernel_s2
	sta $d40a
kernel_s3
	lda allcols,y
	sta $d017
	iny
	inx
	cpx #chr_height
	bne kernel_s2
	
	lda #79
	jsr kernel_wait
	sta $d40a
	lda frame_color
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a
	rts

;=================================================================
init_pm
	lda #3
	sta $d008
	sta $d009
	sta $d00a
	sta $d00b
	lda #$ff
	sta $d00c

	ldx #59
init_pm1
	lda #$fe
	sta pm+pm_yoffset1+$400,x
	sta pm+pm_yoffset1+$500,x
	sta pm+pm_yoffset1+$600,x
	sta pm+pm_yoffset1+$700,x
	sta pm+pm_yoffset2+$400,x
	sta pm+pm_yoffset2+$500,x
	sta pm+pm_yoffset2+$600,x
	sta pm+pm_yoffset2+$700,x
	dex
	bpl init_pm1

	ldx #glines+1
	lda #$ff
init_pm4
	sta pm+pm_yoffset3+$400-1,x
	sta pm+pm_yoffset3+$500-1,x
	sta pm+pm_yoffset3+$600-1,x
	sta pm+pm_yoffset3+$700-1,x
	dex
	bpl init_pm4
	rts

;=================================================================
; <A> contains number to be printed in BCD format.
set_number
	sta x1
	and #$0f	;Compute lower digit offset.
	asl
	asl
	asl
	tax
	ldy #0		;Copy pattern for lower digit.
set_number1
	lda digit1,x
	sta digit,y
	inx
	iny
	cpy #7
	bne set_number1
	
	lda x1		;Compute upper digit offset.
	and #$f0
	lsr
	tax
	ldy #0		;Compute pattern for lower digit.
set_number2
	lda digit1,x
	asl
	asl
	asl
	asl
	ora digit,y
	sta digit,y
	inx
	iny
	cpy #7
	bne set_number2
	
	ldx #0
	stx x1
set_number3
	ldy x1
	lda digit,y
	ldy #8
set_number4
	sta pm+pm_yoffset3+$300+4,x
	inx
	dey
	bne set_number4
	inc x1
	cpx #glines-8
	bne set_number3
	rts

digit1	.byte $f,$9,$9,$9,$9,$9,$f,0
	.byte $1,$1,$1,$1,$1,$1,$1,0
	.byte $f,$1,$1,$f,$8,$8,$f,0
	.byte $f,$1,$1,$f,$1,$1,$f,0
	.byte $9,$9,$9,$f,$1,$1,$1,0
	.byte $f,$8,$8,$f,$1,$1,$f,0
	.byte $f,$8,$8,$f,$9,$9,$f,0
	.byte $f,$1,$1,$1,$1,$1,$1,0
	.byte $f,$9,$9,$f,$9,$9,$f,0
	.byte $f,$9,$9,$f,$1,$1,$f,0

;=================================================================
init_ctab
	ldx #59
init_ctab1
	lda cpat,x
	ldy #0
	cpx #30
	bcs *+3
	iny
	ora ccol1,y
	sta ctaba,x
	sta ctab01,x
	sta ctab02,x
	sta ctab03,x
	sta ctab04,x
	sta ctab05,x
	
	lda cpat,x
	ora ccol2,y
	sta ctabb,x
	sta ctab11,x
	sta ctab12,x	
	sta ctab13,x
	sta ctab14,x
	sta ctab15,x
	dex
	bpl init_ctab1
	rts

cpat
;;	.byte 0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14,0,14
	.byte 0,0
	.byte 0,0,2,0
	.byte 2,2,4,2
	.byte 4,4,6,4
	.byte 6,6,8,6
	.byte 8,8,10,8
	.byte 10,10,12,10
	.byte 12,12,14,12
	.byte 14,14,14,14
	.byte 12,14,12,12
	.byte 10,12,10,10
	.byte 8,10,8,8
	.byte 6,8,6,6
	.byte 4,6,4,4
	.byte 2,4,2,2
	.byte 0,2,0,0
	.byte 0,0

ccol1	.byte $30,$70
ccol2	.byte $b0,$10

;=================================================================
init_gtab
	ldx #glines-1
	lda #0
init_gtab1
	lda #0
	sta gtab1,x
	txa
	asl
	asl
	and #$f0
	ora #$08
	sta gtab2,x
	dex
	bpl init_gtab1
	rts

;=================================================================
init_allcols
	ldx #0
init_allcols1
	txa			;Generate_AllCols
	and #$f0
	sta x1
	txa
	and #31
	cmp #16
	bcc *+4
	eor #31
	ora x1
	sta allcols,x
	inx
	bne init_allcols1
	rts
	
;=================================================================

getkey	lda $d20f
	and #4
	bne getkey
getkey1	lda $d20f
	and #4
	beq getkey1
	rts

;===============================================================
pos0	.word 0
max_pos	= [44+40]*4
pos	.word 0

pos_top	= max_pos+81
pos_bottom	= -91

set_lms
	add pos0,1
	lda pos0+1
	cmp #>max_pos
	bcc set_lms1
	lda pos0
	cmp #<max_pos
	bcc set_lms1
	set pos0,0

set_lms1
	ldx bounce_cnt		;lo
	lda bounce_cnt+1	;hi
	clc
	adc #>bounce_sin
	sta set_lms2+2
	clc
	adc #2
	sta set_lms3+2
	
	lda #<pos_top
	sec
set_lms2
	sbc bounce_sin,x
	pha
	lda #>pos_top
set_lms3
	sbc bounce_sin+$200,x
	tay
	pla
	tax

	set p1,dl_abbuc1
	jsr set_lmsa
	stx offset0
	sty xscroll0

	ldx bounce_cnt
	lda bounce_cnt+1
	clc
	adc #>bounce_sin
	sta set_lms4+2
	clc
	adc #2
	sta set_lms5+2
	lda #<pos_bottom
	clc
set_lms4
	adc bounce_sin,x
	pha
	lda #>pos_bottom
set_lms5
	adc bounce_sin+$200,x
	tay
	pla
	tax
	
	set p1,dl_abbuc2
	jsr set_lmsa
	stx offset1
	sty xscroll1
	rts

set_lmsa
	cpy #$00
	bmi set_lmsb
	cpy #>max_pos
	bcc set_lmsc
	cpx #<max_pos
	bcc set_lmsc
set_lmsb
	ldx #0
	ldy #0
set_lmsc

	stx pos
	sty pos+1
	stx x1
	sty x2

	lda x1
	and #3
	eor #3
	pha

	lsr x2
	ror x1
	lsr x2
	ror x1
	
	clc			;Address of top left sm byte.
	lda #<sm
	adc x1
	sta x1
	lda #>sm
	adc #0
	sta x2

	dic p1
	lda p1			;Address of LO byte in LMS instruction.
	sta set_lmse+1
	lda p1+1
	sta set_lmse+2

	ldx #0
	lda x1			;SM width must be $80 to make this work.
set_lmse
	sta $ffff,x
	eor #sm_width
	inx
	inx
	inx
	cpx #3*abbuc_height
	bne set_lmse

	sec
	lda #<max_pos
	sbc pos
	sta x1
	lda #>max_pos
	sbc #0
	sta x2

	ldx x1		;x returns the softscroll offset.
	pla		;y returns the pm x-position offset.
	tay
	rts

;===============================================================
init_gchr
	ldx #0
	lda #0
	sta x1
init_gchr1
	lda x1
	cmp #$10
	bcc *+4
	eor #$1f
	sta x2
	asl
	asl
	asl
	asl
	ora x2

	sta gchr+$200,x
	sta gchr+$201,x
	sta gchr+$202,x
	sta gchr+$203,x
	sta gchr+$304,x
	sta gchr+$305,x
	sta gchr+$306,x
	sta gchr+$307,x

	lda x1
	clc
	adc #1
	and #$1f
	clc
	cmp #$10
	bcc *+4
	eor #$1f
	sta x2
	asl
	asl
	asl
	asl
	ora x2
	sta gchr+$204,x
	sta gchr+$205,x
	sta gchr+$206,x
	sta gchr+$207,x
	sta gchr+$300,x
	sta gchr+$301,x
	sta gchr+$302,x
	sta gchr+$303,x

	clc
	txa
	adc #8
	tax
	inc x1
	lda x1
	cmp #32
	bne init_gchr1

	ldx #0
init_gsm1
	lda gpat,x
	ora #$80
	sta gsm,x
	lda gpat+$100,x
	ora #$80
	sta gsm+$100,x
	inx
	bne init_gsm1
	rts

;	.byte '0123456789abcdef0123456789abcdef0123456789abcdef'
gpat	.byte "LMNOPQRSTUVWXYZ[\]^__^]\[ZYXWVUTSRQPONML"
	.byte "NOPQRSTUVWXYZ[\]^_@AA@_^]\[ZYXWVUTSRQPON"
	.byte "PQRSTUVWXYZ[\]^_@ABCCBA@_^]\[ZYXWVUTSRQP"
	.byte "RSTUVWXYZ[\]^_@ABCDEEDCBA@_^]\[ZYXWVUTSR"
	.byte "rstuvwxyz{|}~`abcdeedcba`~}|{zyxwvutsr"
	.byte "pqrstuvwxyz{|}~`abccba`~}|{zyxwvutsrqp"
	.byte "nopqrstuvwxyz{|}~`aa`~}|{zyxwvutsrqpon"
	.byte "lmnopqrstuvwxyz{|}~~}|{zyxwvutsrqponml"
	
	.byte "HIJKLMNOPQRSTUVWXYZ[\]^__^]\[ZYXWVUTSRQPONMLKJIH"
	.byte "JKLMNOPQRSTUVWXYZ[\]^_@AA@_^]\[ZYXWVUTSRQPONMLKJ"
	.byte "LMNOPQRSTUVWXYZ[\]^_@ABCCBA@_^]\[ZYXWVUTSRQPONML"
	.byte "NOPQRSTUVWXYZ[\]^_@ABCDEEDCBA@_^]\[ZYXWVUTSRQPON"
	.byte "nopqrstuvwxyz{|}~`abcdeedcba`~}|{zyxwvutsrqpon"
	.byte "lmnopqrstuvwxyz{|}~`abccba`~}|{zyxwvutsrqponml"
	.byte "jklmnopqrstuvwxyz{|}~`aa`~}|{zyxwvutsrqponmlkj"
	.byte "hijklmnopqrstuvwxyz{|}~~}|{zyxwvutsrqponmlkjih"

;===============================================================
bounce
	lda bounce_flag
	bne bounce1
	rts

bounce1
	ldx bounce_cnt		;lo
	ldy bounce_cnt+1	;hi
	lda bounce_dir		;dir
	bne bounce2
	inx
	bne *+3
	iny
	cpx #$ff
	bne bounce3
	cpy #$01
	bne bounce3
	lda #0
	sta bounce_flag
	rts

bounce2	dex
	cpx #$ff
	bne bounce3
	dey
	bpl bounce3
	lda #0
	sta bounce_flag
	rts

bounce3
	stx bounce_cnt
	sty bounce_cnt+1
	rts

;===============================================================
sz	= 30

anim_gchr
	lda anim_flag
	bne *+3
	rts

	lda cnt
	and #1
	bne *+3
	rts

	ldx #7
anim_gchr1
	lda gchr+$200,x
	sta buffer1,x
	lda gchr+$300,x
	sta buffer2,x
	dex
	bpl anim_gchr1

	jsr ganim
	
	ldx #7
anim_gchr3
	lda buffer1,x
	sta gchr+$2f8,x
	lda buffer2,x
	sta gchr+$3f8,x
	dex
	bpl anim_gchr3
	rts

;===============================================================
	.macro bar
	lda #%1+4
	sta %2,y
	sta %2+6,y
	lda #%1+8
	sta %2+1,y
	sta %2+5,y
	lda #%1+10
	sta %2+2,y
	sta %2+4,y
	lda #%1+12
	sta %2+3,y
	.endm

	.macro ypos
	lda x1
	asl
	sec
	sbc #%1*16+[%2*64]
	tay
	lda bsinus,y
	clc
	adc csinus,x
	.if %2>0
	sta x2
	sec
	lda #abbuc_height
	sbc x2
	.endif
	tay
	.endm

anim_ctab
	lda #64
	sta x1
	set p1,512
anim_ctab0
	jsr frame
	
	ldx #59
anim_ctab1
	lda ctaba,x
	sta ctab01,x
	sta ctab02,x
	sta ctab03,x
	sta ctab04,x
	sta ctab05,x
	
	lda ctabb,x
	sta ctab11,x
	sta ctab12,x	
	sta ctab13,x
	sta ctab14,x
	sta ctab15,x
	dex
	bpl anim_ctab1
	
	ldx x1
	ypos 0,0
	bar bc11,ctab11
	ypos 1,0
	bar bc12,ctab12
	ypos 2,0
	bar bc13,ctab13
	ypos 3,0
	bar bc14,ctab14
	ypos 4,0
	bar bc15,ctab15

	ypos 0,1
	bar bc21,ctab01
	ypos 1,1
	bar bc22,ctab02
	ypos 2,1
	bar bc23,ctab03
	ypos 3,1
	bar bc24,ctab04
	ypos 4,1
	bar bc25,ctab05
	
	inc x1
	dec p1
	bne anim_ctab2
	dec p1+1
	bmi anim_ctab3
anim_ctab2
	jmp anim_ctab0
anim_ctab3
	rts

bc11	= $30
bc12	= $40
bc13	= $60
bc14	= $80
bc15	= $a0

bc21	= $50
bc22	= $70
bc23	= $90
bc24	= $b0
bc25	= $c0

;================================================================
printa	ldx #38			;Print_one_ASC
printa1	cmp code,x		;Find_Char_in_MaxChars-1
	beq printa2
	dex
	bpl printa1
	set p1,chr		;Char_Base
	jmp printa6		;unknown_Char_SPACE

printa2
	set p1,chr		;Char_Base
printa3	cpx #13
	bcc printa5
	add p1,chr_block	;next_CharPic_line
	txa
	sec
	sbc #13
	tax
	jmp printa3

printa5	cpx #0
	beq printa6
	add p1,chr_width
	dex
	jmp printa5

printa6	rts

;================================================================
scroll	lda #1
	sta scrsoft		;Softscroll_Index
	sta scrspd		;Softscroll_Speed
	sta scrhold		;Softscroll_Hold

	lda #$b0		;Softscroll_Color
	sta scrcol
	lda #0
	sta scrend
	sta scrbyte
	sta brkflag

	sta dl_scroll1+1
	set pp,ssm

scroll1	jsr sprint		;Get_Char/Adress
	ldy #chr_width
	sty scrbyte
scroll2	jsr sprint7		;Print_one_colum
	jsr sprint9		;LMS_Flipping
	jsr sprint10		;Softscroll
	dec scrbyte		;next_charbyte
	bne scroll2

	lda scrend
	beq scroll3
	dec scrend
	beq scroll4

scroll3	lda brkflag
	beq scroll1
	lda #0
	sta brkflag
	lda #11
	sta scrend
	jmp scroll1

scroll4	jsr scroll_off
	rts

scroll_on
	set dl_branch,dl_scroll	;Scroller_Display
	lda #1
	sta scroll_flag		;Scroll_is_on_(=>DLI)
	rts

scroll_off
	lda #0
	sta scroll_flag
	set dl_branch,dl_gchr ;GCHR_Display
	rts
	
;================================================================
inctp	inc tp
	bne inctp1
	inc tp+1
inctp1	rts

sprint	lda scrend
	bne sprint5
sprint0	ldy #0			;Get_next_char
	lda (tp),y
	jsr inctp		;next_char

	cmp #0
	bne sprint1		;end_Text
	lda #1
	sta brkflag
	rts

sprint1	cmp #speed		;Set_Speed.
	bne sprint2
	lda (tp),y
	sta scrspd
	jsr inctp
	jmp sprint0

sprint2	cmp #hold
	bne sprint3
	lda (tp),y		;Set_Hold
	sta scrhold
	jsr inctp
	jmp sprint0

sprint3	cmp #$82
	bne sprint4
	lda (tp),y		;Set_Colors
	sta scrcol
	jsr inctp
	jmp sprint0

sprint4	cmp #32			;SPACE
	beq sprint5
	jsr printa		;Get_Charadress
	lda #$b1		;LDA (p1),y
	ldx #p1
	bne sprint6		;Space_?
sprint5	lda #$a9		;LDA #$00
	ldx #$00
sprint6	sta sprint8
	stx sprint8+1
	lda pp			;SM_Adresses
	sta p2
	ora #64
	sta p3
	lda pp+1
	sta p2+1
	sta p3+1
	rts

sprint7	ldx #chr_height		;print_colum
	ldy #0
sprint8	lda (p1),y
	sta (p2),y
	sta (p3),y
	add p1,chr_bpl
	clc
	lda p2
	adc #$80
	sta p2
	ora #$40
	sta p3
	lda p2+1
	adc #0
	sta p2+1
	sta p3+1
	dex
	bne sprint8
	sub p1,[chr_block-1]	;get_back_but_one
	clc
	lda pp			;Next_SM_Adresses
	adc #1
	and #63
	sta pp
	sta p2
	ora #64
	sta p3
	lda pp+1
	sta p2+1
	sta p3+1
	rts

sprint9	clc			;LMS_Flipping_!
	lda dl_scroll1+1
	adc #1
	and #$3f
	sta dl_scroll1+1
	sta dl_scroll1+7
	sta dl_scroll1+13
	sta dl_scroll1+19
	sta dl_scroll1+25
	sta dl_scroll1+31
	sta dl_scroll1+37
	sta dl_scroll1+43
	sta dl_scroll1+49
	sta dl_scroll1+55
	sta dl_scroll1+61
	sta dl_scroll1+67
	sta dl_scroll1+73
	sta dl_scroll1+79
	sta dl_scroll1+85
	sta dl_scroll1+91
	sta dl_scroll1+97
	sta dl_scroll1+103
	sta dl_scroll1+109
	sta dl_scroll1+115
	sta dl_scroll1+121
	ora #$80
	sta dl_scroll1+4
	sta dl_scroll1+10
	sta dl_scroll1+16
	sta dl_scroll1+22
	sta dl_scroll1+28
	sta dl_scroll1+34
	sta dl_scroll1+40
	sta dl_scroll1+46
	sta dl_scroll1+52
	sta dl_scroll1+58
	sta dl_scroll1+64
	sta dl_scroll1+70
	sta dl_scroll1+76
	sta dl_scroll1+82
	sta dl_scroll1+88
	sta dl_scroll1+94
	sta dl_scroll1+100
	sta dl_scroll1+106
	sta dl_scroll1+112
	sta dl_scroll1+118
	rts

sprint10
sprint11
	jsr frame		;Softscroll
	lda scrsoft
	sec
	sbc scrspd		;do_Speed
	sta scrsoft
	bpl sprint11
	and #3
	sta scrsoft
sprint12
	lda scrhold		;Count_Hold_value
	beq sprint13
	jsr frame
	dec scrhold
	bne sprint12
sprint13
	rts

;================================================================
speed	= $80
hold	= $81
color	= $82


text1	.byte speed,2,color,$34,"  hello!          ",hold,100, speed, 3, "           "
	.byte "he ",speed,1,color,$28,"finally reached the right edge of the screen ...         ", speed, 4,"michal          ", hold, 50," michalowski        ", hold, 50,"       our grey!         ", hold, 100
	.byte "            "
	.byte speed,1, color,$dc, "celebrates his 39th birthday today. best wishes from              "
	.byte "    pet", speed,4, color,$9c, "er           ", hold,100, "                "
	.byte "    patr", speed,4, color,$dc, "icia         ", hold,100, "                "
	.byte "    hel", speed,4, color,$5c, "ena          ", hold,100, "                "
	.byte "    jana", speed,4, color,$4c, "           ", hold,100, "                "
	.byte color,$0c, speed,1
	.byte "     have a great party and stay atari!                "
	.byte "    "
	.byte 0

;===============================================================

*	= ganim
	.rept 62
	lda gchr+$200+8+[[*-ganim]/sz*4]
	sta gchr+$200+[[*-ganim]/sz*4]
	sta gchr+$201+[[*-ganim]/sz*4]
	sta gchr+$202+[[*-ganim]/sz*4]
	sta gchr+$203+[[*-ganim]/sz*4]
	lda gchr+$300+8+[[*-ganim]/sz*4]
	sta gchr+$300+[[*-ganim]/sz*4]
	sta gchr+$301+[[*-ganim]/sz*4]
	sta gchr+$302+[[*-ganim]/sz*4]
	sta gchr+$303+[[*-ganim]/sz*4]
	.endr
	rts

;===============================================================
*	= dl
dc	= $1e
	.byte $70,$70,$60+$80,$00
dl_abbuc1
	.rept 60
	.byte $40+dc
	.word sm+[[*-dl_abbuc1-1]/3]*sm_width
	.endr
	.byte $20,$01
dl_branch
	.word dl_gchr
dl_gchr	.byte $42
	.word gsm
	.byte 2,2,2,2,2,2,2
	.byte $30
dl_abbuc2
	.rept 60
	.byte $40+dc
	.word sm+[[*-dl_abbuc2-1]/3]*sm_width
	.endr

	.byte $41
	.word dl

;;
dl_scroll
	.rept 11
	.byte $4f
	.word empty
	.endr

dl_scroll1
	.rept 41
	.byte $5f
	.word ssm+[[*-dl_scroll1-1]/3]*ssm_width
	.endr
	.rept 12
	.byte $4f
	.word empty
	.endr
	.byte $20,$01
	.word dl_abbuc2

empty	.ds 40

; Scrolling variables
scrcol	.byte 0			;Scroll_Color_offset
scrbyte	.byte 0			;Scroll_byte_counter
scrsoft	.byte 0			;Scroll_pixel_counter
scrhold	.byte 0			;Scroll_hold_counter
scrspd	.byte 0			;Scroll_speed_value
scrend	.byte 0			;Scroll_end_flag/counter

code	.byte "abcdefghijklmnopqrstuvwxyz0123456789:.!"

;===============================================================

*	= chr
	.incbin "Grey39.chr"

*	= abbuc_pic
	.incbin "Grey39-160x60.pic"
	
*	= bounce_sin
	.incbin "Grey39.sin"

*	= sound
	.incbin "Grey39-PelzerBsm2.snd"

*	= sinus
	.incbin "Grey39-Sinus256.sin"

*	= $2e0
	.word start
